<script>
  import { createEventDispatcher } from 'svelte';

  export let value = null;
  export let options = [];
  export let identify = item => item;
  export let valueAsId = false;

  const dispatch = createEventDispatcher();

  let parsedOptions = [];

  $: multiple = value instanceof Array;
  $: valueId = (() => {
    if (valueAsId) return value;
    return multiple ? value.map(identify) : identify(value);
  })();
  // $: console.log(valueId);

  function indexOf(option) {
    if (multiple) {
      return valueId.findIndex((id) => identify(option) === id);
    }
    return -1;
  }
  
  function isSelected(option) {
    if (multiple) {
      const index = indexOf(option);
      return index !== -1;
    }

    return identify(option) === valueId;
  }

  function setValue(newValue) {
    value = newValue;
    dispatch('change', newValue);
  }

  function toggleOption(option) {
    if (!multiple) {
      if (isSelected(option)) {
        setValue(null);
      } else {
        setValue(valueAsId ? identify(option) : option);
      }
      return;
    }

    const index = indexOf(option);
    if (index === -1) {
      setValue([
        ...value,
        valueAsId ? identify(option) : option,
      ]);
    } else {
      value.splice(index, 1);
      setValue([...value]);
    }
  }

  $: multiple, value, parsedOptions = options.map((option) => ({
    option,
    selected: isSelected(option),
  }));
</script>

{#each parsedOptions as { option, selected }}
  <slot {option} {selected} toggle={() => toggleOption(option)} />
{/each}
